/*************************************************************************
 *                           Smart Active Node                           * 
 *                      copyright (C) 2007 KIV-FAV-ZCU                   *
 *************************************************************************
 * The licence for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package login;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

import san.core.ExecuteException;
import san.core.IApplicationAPI;
import san.application.IApplication;
import san.ident.Guid;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> Login.java<br>
 * @author Michal Rejda
 * @since 8.11.2007
 * @version 1.0
 */
public class Login implements IApplication {

	public void main(String[] args, IApplicationAPI applicationAPI, Guid guid) {
		PrintWriter out = applicationAPI.getStdOut();
		BufferedReader br = new BufferedReader(new InputStreamReader(applicationAPI.getStdIn()));
		try{
			while(true) {
				out.print("Login: ");
				br.readLine();
				out.print("Password: ");
				br.readLine();
				try{
					Guid shellGuid = applicationAPI.runApplication("shell", null);
					applicationAPI.waitForApplication(shellGuid);
				}
				catch(InterruptedException e) {
					out.write(e.getMessage());
				}catch(ExecuteException e) {
					out.write(e.getMessage());
				}
				out.println();
			}
		}catch(IOException e) {
			out.write(e.getMessage());
		}
	}
}
