/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.core;

import san.logging.ILogger.LogType;
import san.logging.LoggerFactory.LogOutput;

/**
 * <b>Title:</b> Smart Active Node <b>Description:</b> Base settings of Smart
 * Active Node.
 * @author Jan Boháč, Michal Rejda
 * @since 28.11.2006
 * @version 1.1
 */
public class BaseSettings {

	static private BaseSettings bs = null; // singleton
	/**
	 * @uml.property name="serverName"
	 */
	private String serverName = "";
	/**
	 * @uml.property name="logLevel"
	 */
	private LogType logLevel = LogType.ERROR;
	/**
	 * @uml.property name="logOutput"
	 */
	private LogOutput logOutput = LogOutput.FILE;

	private BaseSettings() {
	}

	/**
	 * Return base settiongs of this node.
	 */
	public static BaseSettings getSettings() {
		if (bs == null)
			bs = new BaseSettings();
		return bs;
	}

	/**
	 * @return the logLevel
	 * @uml.property name="logLevel"
	 */
	public LogType getLogLevel() {
		return logLevel;
	}

	/**
	 * @param logLevel the logLevel to set
	 * @uml.property name="logLevel"
	 */
	public void setLogLevel(LogType logLevel) {
		this.logLevel = logLevel;
	}

	/**
	 * Getter of the property <tt>logOutput</tt>
	 * @return Returns the logOutput.
	 * @uml.property name="logOutput"
	 */
	public LogOutput getLogOutput() {
		return logOutput;
	}

	/**
	 * Setter of the property <tt>logOutput</tt>
	 * @param logOutput The logOutput to set.
	 * @uml.property name="logOutput"
	 */
	public void setLogOutput(LogOutput logOutput) {
		this.logOutput = logOutput;
	}

	/**
	 * Getter of the property <tt>serverName</tt>
	 * @return Returns the serverName.
	 * @uml.property name="serverName"
	 */
	public String getServerName() {
		return serverName;
	}

	/**
	 * Setter of the property <tt>serverName</tt>
	 * @param serverName The serverName to set.
	 * @uml.property name="serverName"
	 */
	public void setServerName(String serverName) {
		this.serverName = serverName;
	}
}
