/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/

package san.data;

import java.io.Serializable;


/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> Representation of some data.<br>
 * @author Jan Boháč, Michal Rejda
 * @since 30.10.2006
 * @version 1.0
 */
public class TransmitData implements Serializable {
	
	private byte[] data;
	
	public TransmitData(){
		this.data = null;
	}
	
	public TransmitData(byte[] data) {
		this.data = data;
	}
	
	public void setData(byte[] data) {
		this.data = data;
	}
	
	public String toString() {
		String s = "";
		for (int i = 0; i < data.length; i++) {
			s += data[i] + "";
		}
		return s;
	}
	
	public byte[] getData() {
		return data;
	}
}
