package san.interpreter.sanint.executeMonitor;

import org.apache.log4j.Logger;

import san.interpreter.sanint.interpreter.SanInterpreter;


public class ExecuteMonitor {
	
	private static final transient Logger log = Logger.getLogger(SanInterpreter.class);
	
	byte[] bytecode = null;
	int[] executeCount = null;
	int maxRepeatCount = 0;
	long executeStart = 0;
	
	public ExecuteMonitor(byte[] bytecode, int maxRepeatCount) 
	{
		this.bytecode = bytecode;
		this.maxRepeatCount = maxRepeatCount;
		this.executeCount = new int[bytecode.length];
		this.executeStart = System.currentTimeMillis();
	}
	
	public void testInstruction(int index) 
	throws ExecuteException
	{
		//if(++this.executeCount[index] > this.maxRepeatCount)
		//	throw new ExecuteException("MAX count of repeat reached - Instruction " + "0x" + 
		//								Integer.toHexString(this.bytecode[index]) + " - " + this.maxRepeatCount + "x");
	}
	
	public void totalRepeat()
	{
		long sum = 0;
		for(int a = 0; a < executeCount.length; a++)
			sum += executeCount[a];
		
		if (log.isTraceEnabled()) {
			//System.out.println("Total count of instruction: " + sum);
			log.trace("Total count of instruction: " + sum);
		}
		
	}
	
	public void getExecuteTime(boolean formatOutput)
	{
		long timeInMiliSeconds = System.currentTimeMillis() - this.executeStart;
		
		if(!formatOutput)
		{
			if (log.isTraceEnabled()) {
				//System.out.println("Program duration: " + timeInMiliSeconds + " milisecond(s)");
				log.trace("Program duration: " + timeInMiliSeconds + " milisecond(s)");
			}
			
			
			return;
		}
		
		int timeInSeconds = (int)(timeInMiliSeconds / 1000);
		
		int hours, minutes, seconds;
		hours = timeInSeconds / 3600;
		timeInSeconds = timeInSeconds - (hours * 3600);
		minutes = timeInSeconds / 60;
		timeInSeconds = timeInSeconds - (minutes * 60);
		seconds = timeInSeconds;
		
		if (log.isTraceEnabled()) {
			//System.out.println("Program duration: " + hours + " hour(s) " + minutes + " minute(s) " + seconds + " second(s)");
			log.trace("Program duration: " + hours + " hour(s) " + minutes + " minute(s) " + seconds + " second(s)");
		}
		
	}

}
