package san.interpreter.sanint.test;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Date;

/*************************************************************************
 *                           Smart Active Node                           * 
 *                      copyright (C) 2007 KIV-FAV-ZCU                   *
 *************************************************************************
 * The licence for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/


/**
 * <b>Title:</b> Smart Active Node<br> 
 * <b>Description:</b> PingCapsule.java<br>
 * @author Michal Rejda
 * @since 23.10.2007
 * @version 1.0
 */
public class Test implements ICapsule {
	
	
	
	public void main(ICapsuleAPI capsuleAPI) {
		try{
		TransmitData data = capsuleAPI.getDataLoad();
		
		ObjectInputStream ois = new ObjectInputStream(new ByteArrayInputStream(data.getData()));
		boolean returnBack = ois.readBoolean();
		
		if(returnBack) {
			//capsule is on the back way
			if(capsuleAPI.isThisServer(capsuleAPI.getDestination())) {
				System.out.println("we are on the source server with application ping");
				//we are on the source server with application ping
				
				//sending data back to the application
				capsuleAPI.sendData(capsuleAPI.getSourceApplication(), data);
				
				//end of capsule live
				capsuleAPI.finished();
			} else {
				System.out.println("doing nothing");
			}
		} else {
			//capsule is on the way to the destination node
			
			NetIdentifier pingDestination = (NetIdentifier) ois.readObject();
			if(capsuleAPI.isThisServer(pingDestination)){
				//we are on the destination node
				
				//change destination for the way back
				capsuleAPI.setDestination(capsuleAPI.getSource());
				
				//creating payload for capsule
				ByteArrayOutputStream bos = new ByteArrayOutputStream();
				ObjectOutputStream oos = new ObjectOutputStream(bos);
				oos.writeBoolean(true);	//we are on the back way
				oos.writeObject(pingDestination);	//destination of the ping (this node)
				oos.writeObject(new Date());	//timestamp
				oos.close();

				//set payload
				capsuleAPI.setDataLoad(new TransmitData(bos.toByteArray()));
				
			} else {

			}
		}
		}catch(Exception e) {
			System.err.println(e);
			e.printStackTrace();
		}
	}
}
