/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.networkInterfaces;

import san.networkInterfaces.NetInterface;
import san.networkInterfaces.RemoteInterface;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> This interface is listener that listen to changing in
 * connection from network interface to another network interface.<br>
 * @author Michal Rejda
 * @since 6.12.2007
 * @version 1.0
 */
public interface IConnectionChangedListener {

	/**
	 * Indicate that new remote interface was added to network interface. New
	 * connection to another node has arose.
	 */
	public abstract void remoteInterfaceAdded(NetInterface localInterface,
			RemoteInterface remoteInterface);

	/**
	 * Indicate that connection to node has been lost.
	 */
	public abstract void remoteInterfaceLost(NetInterface localInterface,
			RemoteInterface remoteInterface);
}
