package san.security.userSecurity;

import java.io.File;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;
import java.util.StringTokenizer;

/**
 * Adds an user to the users repository of this node
 * @author Alexandre
 *
 */
public class AddUser {

	//Method to load passwords
	public static List<String> getUsers(String key){

		LinkedList<String> lista = new LinkedList<String>();
		try {
			//Apenas Para verificar se o ficheiro existe
			File file = new File("node.passwords" );
			Scanner sc = new Scanner(file);			
			sc.close();

			lista = (LinkedList)UserSecurity.checkMAC(key);

			if (lista == null){
				System.out.println("Password error or corrupted file!!");
				System.out.println("If problem persists eliminate the file");
				System.exit(0);
			}

		} 
		catch (Exception ex){
			System.err.println("Non existing file, it will be created!");
			return new LinkedList<String>();
		}

		return lista;

	}

	//Method to recieve user information
	public static void getArgs(LinkedList<String> lista, String nome, String pwd){

		int id;

		if (lista.size()==0)
			id = 1;
		else {
			StringTokenizer token = new StringTokenizer((String)lista.getLast(),";");
			String idToken = token.nextToken();
			id = 1+Integer.decode(idToken);
		}

		byte [] stx = UserSecurity.stringToSintexe(pwd,"SHA1");

		String code = new sun.misc.BASE64Encoder().encode(stx);
		//    System.out.println("byte "+code);

		lista.add(id+";"+code+";"+nome);

		System.out.println("Your indentification is : "+id);
	}
	
	//Method to store passwords
	public static void writePwds(List<String> lista,String key){
		UserSecurity.saveMAC(key,lista);
	}
}
