#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <pthread.h>

#include "ii.h"

int csock1, csock2;

void read_write(int s1, int s2) {
    int rdbytes = 0;
    char buffer[4096];

    printd("read %d write %d", s1, s2);

    while ((rdbytes = recv(s1, buffer, 4096, 0)) > 0) {
        send(s2, buffer, rdbytes, 0);
    }

    printd("end read %d write %d", s1, s2);
}

void *read1_write2(void *arg) {
    read_write(csock1, csock2);
}

void *read2_write1(void *arg) {
    read_write(csock2, csock1);
}

void connector(void) {
    int sock1, sock2;
    struct sockaddr_in my_addr, rem_addr;
    pthread_t vlakno1, vlakno2;
    unsigned int    rem_addr_length;

    if ((sock1 = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1) {
        perror("sock1");
        exit(EXIT_FAILURE);
    }

    if ((sock2 = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1) {
        perror("sock1");
        exit(EXIT_FAILURE);
    }

    my_addr.sin_family = AF_INET;
    my_addr.sin_addr.s_addr = INADDR_ANY;
    my_addr.sin_port = htons(4441);

    if (bind(sock1, (struct sockaddr *) &my_addr, sizeof(my_addr)) == -1) {
        perror("bind1");
    };

    my_addr.sin_family = AF_INET;
    my_addr.sin_addr.s_addr = INADDR_ANY;
    my_addr.sin_port = htons(4442);
    if (bind(sock2, (struct sockaddr *) &my_addr, sizeof(my_addr)) == -1) {
        perror("bind2");
    };

    listen(sock1, 1);
    listen(sock2, 1);

    printd("Waiting for connection 1");

    if ((csock1 = accept(sock1, (struct sockaddr *)&rem_addr, &rem_addr_length)) == -1) {
        perror("acccept1");
    };

    printd("Waiting for connection 1");

    if ((csock2 = accept(sock2, (struct sockaddr *)&rem_addr, &rem_addr_length)) == -1) {
        perror("acccept2");
    };

    printd("Running");
    
    pthread_create(&vlakno1, NULL, read1_write2, NULL);
    pthread_create(&vlakno2, NULL, read2_write1, NULL);

    pthread_join(vlakno1, NULL);
    pthread_join(vlakno2, NULL);

    printd("Exiting");

    close(csock1);
    close(csock2);
    close(sock1);
    close(sock2);
}

